;;; -*- Gerbil -*-
(import :std/sugar
				:std/getopt
				:std/format
				;; :std/misc/process
				:gerbil/gambit
				:gerbil/expander
				:gerbil/runtime
				:gerbil/runtime/loader
				./lib)

(export main)

(include "../manifest.ss")

;; (defrule (callback key arg body ...)
;;	 (bind key (lambda arg
;; 							body ...)))
;; (import :std/sugar)

;; (defrule (on-release key body ...)
;;	 (bind key (lambda (type)
;; 							(when (= type 0)
;; 								body)
;; 							...)))

;; ;; key A
;; (on-release 30
;; 						(run-process ["notify-send" "oof"])
;; 						(exit))

(def (main . args)
	(call-with-getopt
	 actkbd-main args
	 program: "actkbd"
	 help: "ACT on KeyBoarD events"
	 (flag		 'verbose "-v" help: "Output more information")
	 (flag		 'grab		"-g" help: "Grab the keyboard, getting exclusive
 access to the device")
	 (argument 'device help: "Device file")
	 (argument 'config help: "Configuration file, scheme script")))

(def (actkbd-main opts)
	(let-hash opts
		(set! verbose .?verbose)
		(init-kb .device .?grab)
		(gerbil-load-expander!)
    ;;(add-load-path! .config)
		;; (load-module "example-config.scm")
		(eval `(import ,.config))
		;; (cut )
		(while #t
			(let* ((ev (read-ev)))
				(when verbose
					(eprintf "Keycode: ~a event type: ~a\n"
									 (evt-key ev)
									 (evt-action ev)))
				(call-cb ev)))))

;; GERBIL_LOADPATH=./actkbd .gerbil/bin/actkbd -v /dev/input/event15 actkbd/example-config.scm ;; segfaults
;; add-load-path!                ;; where's the symbol?
;; load-module                   ;; does not find module by absolute or relative path
;; (eval-module .config)            ;; segfaults
;; (import-module .config)           ;; segfaults
;; (eval `(import ,.config))         ;; segfaults

;; 		(module-import-source .config) ;; type error